#ifndef MPP_GRBBING_H_
#define MPP_GRBBING_H_

#include <sstream>

#include <FL/Fl_Window.H>
#include <FL/fl_draw.H>

#include <tiffio.h>

#include <mpp/canvas.h>

#include <typeinfo>

namespace mpp
{
unsigned char * grabbing(Fl_Window *, int x, int y, int dx, int dy);
unsigned char * grabbing(Fl_Window *);
void            grabbing_tif(Fl_Window *, int x, int y, int dx, int dy, const char * fname, int compr=COMPRESSION_DEFLATE);
inline void     grabbing_tif(Fl_Window *,    const char * fname, int compr=COMPRESSION_NONE);
inline void     grabbing_tif(Fl_Window &win, const char * fname, int compr=COMPRESSION_NONE) {
    grabbing_tif(&win, fname, compr);
}

void            grabbing_eps(Fl_Widget *,    const char * fname);
inline void     grabbing_eps(Fl_Widget &win, const char * fname) {
    grabbing_eps(&win, fname);
}
void            grabbing_png(Fl_Widget *,    const char * fname, int rezolution=72);
inline void     grabbing_png(Fl_Widget &win, const char * fname, int rezolution=72) {
    grabbing_png(&win, fname, rezolution);
}
inline const char * i2a(int n, const char * add="");
inline const char * i2a(const char * before, int n, const char * after);
};

void grabbing_(Fl_Window *, const char * fname, int compr=COMPRESSION_DEFLATE);

const char * mpp::i2a(int n, const char * add) {
    static char buff[256];
    std::stringstream ss;
    ss<<n<<add;
    strcpy(buff,ss.str().c_str());
    return buff;
}


const char * mpp::i2a(const char * before, int n, const char * after) {
    static char buff[256];
    std::stringstream ss;
    ss<<before<<n<<after;
    strcpy(buff,ss.str().c_str());
    return buff;
}


void mpp::grabbing_tif(Fl_Window * win, const char * fname, int compr) {
    if ( (dynamic_cast<mpp::Canvas *>(win))) {
        mpp::Canvas *tmp=dynamic_cast<mpp::Canvas *>(win);
        grabbing_(&(tmp->canvas_), fname, compr);
        return ;
    }
    else {
        grabbing_(win, fname, compr);
    }
}
#endif
