#ifndef MPP_STUFF_H_
#define MPP_STUFF_H_

#include <stdlib.h>
#include <utility>

namespace mpp
{

inline double POW(int p) {	 //raise value to the p power
    double tmp=1;
    if (p>0) {
        for (int i=0; i<p; i++)
            tmp*=10;
        return tmp;
    }
    if (p<0) {
        for (int i=0; i>p; i--)
            tmp*=0.1;
        return tmp;
    }
    return tmp;
}

std::pair<double,double> auto_scale(double val) {
    val*=1.07;
    const int sz=8;
    static double ar[sz][2]= { {
            12,2
        }
        ,
        {
            15,2.5
        }
        ,
        {
            20,4
        }
        ,
        {
            30,5
        }
        ,
        {
            40,5
        }
        ,
        {
            50,10
        }
        ,
        {
            70,10
        }
        ,
        {
            100,20
        }
    };
    int p=(int)floor(log(val)/log(10.))-1;
    double tmp=val/POW(p);
    std::pair<double,double> kk(1,1);
    for (int i=0; i<sz; i++)
        if (tmp<=ar[i][0]) {
            double tmp2=POW(p);
            kk.first=ar[i][0]*tmp2;
            kk.second=ar[i][1]*tmp2;
            return kk;
        }
    return kk;
}

};
#endif
