#include <string.h>
#include <FL/Fl_File_Chooser.H>

#include <mpp/file_dialog.h>

char File_Name_str[260];		 // buffer for file name

namespace mpp
{
// native win32 file dialog
#ifdef WIN32
#include <windows.h>
#include <CommDlg.h>
char * file_dialog(const char * message, const char *pattern, const char *fname) {
    OPENFILENAME ofn;		 // common dialog box structure
    //		HWND hwnd;              // owner window
    //		HANDLE hf;              // file handle

    // Initialize OPENFILENAME
    ZeroMemory(&ofn, sizeof(ofn));
    ofn.lStructSize = sizeof(ofn);
    //ofn.hwndOwner = hwnd;
    ofn.hwndOwner = 0;
    ofn.lpstrFile = File_Name_str;
    //
    // Set lpstrFile[0] to '\0' so that GetOpenFileName does not
    // use the contents of szFile to initialize itself.
    //

    strcpy(ofn.lpstrFile, fname);
    //ofn.lpstrFile[0]='\0';
    //strcpy(ofn.lpstrFile, "");
    ofn.nMaxFile = 256;
    ofn.lpstrFilter = pattern;
    ofn.nFilterIndex = 0;
    char tmp_message[260];
    if (message) {
        strcpy(tmp_message,message);
        ofn.lpstrTitle = tmp_message;
        ofn.nMaxFileTitle = strlen(tmp_message);
    }
    ofn.lpstrInitialDir = ".\\";
    ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
    //GetOpenFileName(&ofn);
    if (GetSaveFileName(&ofn) ) return ofn.lpstrFile;
    return 0;
};
#else
char * file_dialog(const char * message, const char *pattern, const char *fname) {
    return fl_file_chooser(message, pattern, fname);
};
#endif

// FLTK dialog
char * file_dialog_f(const char * message, const char *pattern, const char *fname) {
    return fl_file_chooser(message, pattern, fname);
};
// end mpp namespace
};
