#include <string>
#include <sstream>

#include <FL/Fl_Window.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Round_Button.H>

#include <mpp/mpp.h>
#include <mpp/manager.h>

void sh_callback(Fl_Widget *, void * win) {
    ((mpp::Window *) win)->show();
}


void callback_priority(Fl_Widget *, void * val) {
    int * kkk=(int *) val;
    mpp::priority_value=*kkk;
    mpp::priority_changed=true;
}


mpp::Manager * mpp::manager=0;

inline void stop_callback(Fl_Widget *, void *) {
    mpp::stop();
}
inline void start_callback(Fl_Widget *, void *) {
    mpp::start();
}
void close_all_callback(Fl_Widget *, void *) {
    for (std::list<mpp::Window *>::const_iterator p=mpp::window_list().begin(); p!=mpp::window_list().end(); ++p)
        (*p)->hide();
    mpp::manager->hide();
}


mpp::Manager::Manager(int w, int h, const char * name): Fl_Window(w, h, name),
    menubar(0,0,w,30), mb(1,31,80, 30, "View") {
    menubar.add("&Start", FL_ALT+'s', start_callback, 0, 0);
    menubar.add("S&top", FL_ALT+'t', stop_callback, 0, 0);
    menubar.add("Close", FL_ALT+'c', close_all_callback, 0, 0);

    int i=0;
    for (std::list<mpp::Window *>::const_iterator p=mpp::window_list().begin(); p!=mpp::window_list().end(); ++p) {
        std::stringstream str;
        str << i++ << ' ' << (*p)->label() << std::endl;
        std::string s=str.str();
        mb.add(s.c_str(), 0, sh_callback, (*p));
    }

    end();
}


mpp::Manager::~Manager() {
    //mpp::stop();
}
