#include <mpp/mpp.h>
#include <mpp/manager.h>

namespace mpp
{
// task priorities
int priority_hour=8;
int priority_day=14;
int priority_week=19;
int  priority_value=mpp::priority_hour;
bool priority_changed=false;
double sleep_time=0.5;
// new calc functions
void (*Calc_func)(void);	 // new thread
void (*Calc_func_)(void);	 // same thread
void (*Calc_func_3)(void);	 // same thread by timer

// namespace member
bool                            ask_stop=false;
// namespace member
bool                            calc=false;
// namespace member
volatile bool                 suspend_flag=false;
double                            update_time=0.05;
// static member
Group *                    Group::current_=0;
bool                          visible_v=true;
//	const char *                  mppg_info="MPPG";
//	const char *                  mppg_info="MPPG 2.6.0\nMPPG (Modeling Physical Phenomena Graphical User Interface)\nis a cross-platform C++ GUI library for UNIX/Linux (X11),Microsoft Windows.\nMPPG provides GUI for numeric calculations.\nhome: ftp: //ancient.hydro.nsc.ru/local/mppg, user=ftp\nEMail: pru_A_hydro.nsc.ru\n17.07.04";


Widget::Widget() {
    if (Group::current_) {
        mpp_parent_=Group::current_;
        Group::current_->add(this);
    }
    else {
        mpp_parent_=0;
        group_list().push_back(this);
    }
    need_update=true;
}

Group::Group() {
    current_=this;
}

void Group::add(Widget *w) {
    widget_list.push_back(w);
}

void Group::mpp_end() {
    if (mpp_parent_) current_=mpp_parent_;
    else current_=0;
}

void Group::mpp_begin() {
    //current_old=current_;
    current_=this;
}

void Group::update() {
    Widget::update();
    for (std::list<Widget*>::iterator p=widget_list.begin(); p!=widget_list.end(); ++p) {
        //if ((*p)->need_update) {
        (*p)->update();
        //}
    }
}

void Group::ask_update() {
    Widget::ask_update();
    for (std::list<Widget*>::const_iterator p=widget_list.begin(); p!=widget_list.end(); ++p) {
        (*p)->ask_update();
    }
}

void Group::set_value() {
    for (std::list<Widget*>::const_iterator p=widget_list.begin(); p!=widget_list.end(); ++p) {
        (*p)->set_value();
    }
}

Window::Window() {
    if (! mpp_parent_) window_list().push_back(this);
}

void update() {
    for (std::list<Widget*>::iterator p=group_list().begin(); p!=group_list().end(); ++p) {
        (*p)->update();
    }
}

void ask_update() {
    for (std::list<Widget*>::iterator p=group_list().begin(); p!=group_list().end(); ++p)
        (*p)->ask_update();
}

void set_value() {
    for (std::list<Widget*>::const_iterator p=group_list().begin(); p!=group_list().end(); ++p)
        (*p)->set_value();
}

void set_work(void (*f)(void)) {
    Calc_func=f;
}
void set_work2(void (*f)(void)) {
    Calc_func_=f;
}
// set void f(void) to exequte
void set_work3(void (*f)(void), double sleep_time) {
    sleep_time=sleep_time;
    Calc_func_3=f;		 // in the same thread by timer
}

// for mpp manager
std::list<Window*>& window_list() {
    static std::list<Window*> w;
    return w;
}

// for update, ...
std::list<Widget*>& group_list() {
    static std::list<Widget*> w;
    return w;
}

}

