#include <mpp/mpp_window.h>

#ifdef PRINTER
//#include <FL/Fl_PS_Printer.H>
//#include <FL/fl_printer_chooser.H>
#endif

#include <FL/Fl_File_Chooser.H>
#include <FL/fl_draw.H>

inline void stop_callback(Fl_Widget *, void *) {
    mpp::stop();
}
inline void start_callback(Fl_Widget *, void *) {
    mpp::start();
}
inline static void continue_callback(Fl_Widget *, void *) {
    mpp::ask_continue();
}
inline static void suspend_callback(Fl_Widget *, void *) {
    mpp::ask_suspend();
}

/*
static  void print_callback(Fl_Widget * bt, void *w){
Fl_Widget * g = (Fl_Widget *)w;
  Fl_Printer * p = fl_printer_chooser();
  if(!p) return;
  p->page(Fl_Printer::A4);
  // fitting inside margins 1 inch wide
  p->place(g, FL_INCH, FL_INCH, p->page_width() - 2 * FL_INCH, p->page_height() - 2 * FL_INCH,  FL_ALIGN_CENTER);
  Fl_Device * c = p->set_current();
  fl_draw(g);
  c->set_current();
  delete p;

//	Fl_Window * g = (Fl_Window *)w;
//	Fl_Printer * p = fl_printer_chooser();
//	if(!p) return;
//	p->page(Fl_Printer::A4);
//	//p->page(Fl_Printer::LANDSCAPE);
//	p->place(g, FL_INCH, FL_INCH, p->page_width() - 2 * FL_INCH, p->page_height() - 2 * FL_INCH,  FL_ALIGN_CENTER);
//	// fitting inside margins 1 inch wide
//	g->color(FL_WHITE);
//	p->draw(g); // also swaps devices before and after printing
//	g->color(FL_BLACK);
//	delete p; // no need to close file

}

static void printps_callback(Fl_Widget *, void *w) {
	Fl_Widget * g = (Fl_Widget *)w;

	char * filename = fl_file_chooser("Print to file...","*.ps","*.ps");
	if(!filename) return;
	FILE * f = fopen(filename,"w");
	if(!f) return;
	Fl_Printer * p = new Fl_PS_Printer(f, 3);
	p->page(Fl_Printer::A4);
	p->place(g, 70, 70, p->page_width() - 140, p->page_height() - 140,  FL_ALIGN_CENTER);
	Fl_Device * c = p->set_current();
	fl_draw(g);
	c->set_current();
	delete p;
	fclose(f); //we need close file here
//   Fl_Window * g = (Fl_Window *)w;

//    // Fl_Printer * p = fl_printer_chooser();

//    char * filename = fl_file_chooser("Print to file...","*.ps","*.ps");
//    if(!filename) return;
//    FILE * f = fopen(filename,"w");
//    if(!f) return;
//    Fl_Printer * p = new Fl_PS_Printer(f, 3);
//    p->page(Fl_Printer::A4);
//    p->place(g, 70, 70, p->page_width() - 140, p->page_height() - 140,  FL_ALIGN_CENTER);
//    Fl_Output_Device * c = p->set_current();
//    fl_draw(g);
//    c->set_current();
//    delete p;
//    fclose(f); //we need close file here
//
};
  */

mpp::Mpp_window::Mpp_window(int w, int h, const char *name):
    Fl_Window(w, h, name), menubar(0,0,w,30), canvas(0,31,w-249, h-31), table(w-250, 31, 250, h-31) {
    Fl_Window::resizable(canvas);
    end();
    mpp_end();
    menubar.add("&Start", FL_ALT+'s', start_callback, 0, 0);
    menubar.add("S&top", FL_ALT+'t', stop_callback, 0, 0);
    //	menubar.add("&Print2", FL_ALT+'p', printps_callback, (Fl_Widget *)&canvas, 0);
    if (mpp::visible()) show();
}


mpp::Mpp_window::Mpp_window(const char * name): Fl_Window(600, 400, name),
    menubar(0,0,600,30), canvas(0,31,600-249, 400-31, 0), table(600-250, 31, 250, 400-31, 0) {
    Fl_Window::resizable(canvas);
    end();
    mpp_end();
    menubar.add("&Start", FL_ALT+'s', start_callback, 0, 0);
    menubar.add("S&top", FL_ALT+'t', stop_callback, 0, 0);
    //	menubar.add("&Print", FL_ALT+'p', print_callback, (Fl_Widget *)&canvas, 0);
    //	menubar.add("&Print", FL_ALT+'p', print_callback, (Fl_Widget *)this, 0);
    //	menubar.add("&Print2", FL_ALT+'p', printps_callback, (Fl_Widget *)&canvas, 0);
    if (mpp::visible()) show();
}


void mpp::Mpp_window::set_new_mode() {
    menubar.add("Continue", FL_ALT+'p', continue_callback, 0, 0);
    menubar.add("Suspend", FL_ALT+'p', suspend_callback, 0, 0);
}
