#include <mpp/mpp.h>
#include <mpp/manager.h>
#include <FL/Fl.H>

//#include <iostream>

#ifdef POSIX__
pthread_t mpp::tid;
void * calc_func__(void *) {
    mpp::set_priority(mpp::priority_hour);
    mpp::Calc_func();
    mpp::calc=false;
    mpp::ask_stop=false;
    return 0;
}
#endif

#ifdef NTTHREADS__
HANDLE mpp::thread;
DWORD mpp::tid;
DWORD CALLBACK calc_func__(void *) {
    mpp::set_priority(mpp::priority_value);
    mpp::priority_changed=false;
    mpp::Calc_func();
    mpp::calc=false;
    return 0;
}
#endif

void calc_func__2(void *) {
    mpp::Calc_func_();
}


// by timer
void calc_func__3(void *) {
    mpp::Calc_func_3();
    if (mpp::calc) Fl::repeat_timeout(mpp::sleep_time, calc_func__3, 0);
}


void update_callback(void *) {
    mpp::update();
    Fl::repeat_timeout(mpp::update_time, update_callback, 0);
}


namespace mpp
{

void start() {
    suspend_flag=false;
    if (!calc) {
        ask_stop=false;
        calc=true;
        set_value();
        if (Calc_func) {
#ifdef POSIX__
            pthread_create(&tid,0,calc_func__, 0);
            sched_param sch;
            int policy;
            pthread_getschedparam(tid, &policy, &sch);
            sch.sched_priority=14;
            pthread_setschedparam(tid, policy, &sch);
#endif
#ifdef NTTHREADS__
            thread=CreateThread(0,0,calc_func__, 0,0,& mpp::tid);
            SetThreadPriority(thread, THREAD_PRIORITY_BELOW_NORMAL);
#endif
        }
        if (Calc_func_) {
            Fl::add_idle(calc_func__2, 0);
        }
        if (Calc_func_3) {
            Fl::add_timeout(sleep_time, calc_func__3, 0);
        }
        //Fl::add_timeout(1.0, update_callback, 0);
    }
}

void stop() {
    if (suspend_flag) suspend_flag=false;
    if (calc) {
        if (Calc_func) {
            ask_stop=true;
#ifdef POSIX__
            //pthread_join(tid, 0);
#endif
#ifdef NTTHREADS__
            if (WaitForSingleObject(thread, 1000) == WAIT_TIMEOUT)
                TerminateThread(thread, 0);
#endif
        }
        if (Calc_func_) {
            Fl::remove_idle(calc_func__2, 0);
            calc=false;
        }
        if (Calc_func_3) {
            //Fl::remove_idle(calc_func__2, 0);
            calc=false;
        }

        //ask_stop=false;
        //calc=false;
        ask_update();
        update();
    }
}

int run() {
    Fl::lock();
    Fl::visual(FL_DOUBLE|FL_INDEX);

    if (!manager) {
        manager=new Manager;
    }
    update();
    Fl::add_timeout(update_time, update_callback, 0);
    // begin main loop
    int kk=Fl::run();
    // end main loop
    // killing all proceses
    suspend_flag=false;
    if (calc) {
        if (Calc_func) {
            ask_stop=true;
            //while(mpp::calc) Fl::wait();
#ifdef POSIX__
            //pthread_join(mpp::tid, 0);
#endif
#ifdef NTTHREADS__
            if (WaitForSingleObject(thread, 1000) == WAIT_TIMEOUT)
                TerminateThread(thread, 0);
            //TerminateThread(thread, 0);
#endif
        }
    }
    return kk;
};
};
