#include <FL/Fl.H>
#include <fl/Fl_Window.h>
#include <fl/Fl_Overlay_Window.h>
#include <fl/Fl_Menu_Button.h>
#include <FL/fl_draw.H>
#include <iostream>

using namespace std;

Fl_Menu_Item menutable[] = {
	{"foo",0,0,0,FL_MENU_INACTIVE},
	{"kk",0,0,0,0},
	{0}
};

class A:public Fl_Group{
public:
	Fl_Menu_Button mb;
	Fl_Group toolbar;
	A(int x, int y, int w, int h, const char * name):Fl_Group(x,y,w,h,name),mb(0,0,w,h-30,"kk"),toolbar(0,h-30,w,30){
		mb.menu(menutable);
		mb.type(Fl_Menu_Button::POPUP3);
		resizable(&mb);
	}
	int handle(int event){
		switch (event){
			case FL_ENTER:
				fl_cursor(FL_CURSOR_CROSS);
				std::cout << "Canvas_::FL_ENTER" << std::endl;
				return 1;		
			case FL_LEAVE:
				fl_cursor(FL_CURSOR_DEFAULT);
				std::cout << "Canvas_::FL_LEAVE" << std::endl;
				return 1;		
			default :
				//std::cout << "Canvas_::default" << std::endl;
				return Fl_Group::handle(event);
		}
	}
};

class Mwin:public Fl_Overlay_Window{
public:	
	A a;
	Mwin(int x, int y, int w, int h, const char * name):Fl_Overlay_Window(x,y,w,h),a(0,0,w,h-30,"kk"){
		resizable(&a);
		//show();			
	}
	int handle(int event){
		//std::cout << "Mwin::handle" << std::endl;
		switch (event){
			case FL_ENTER:
				fl_cursor(FL_CURSOR_CROSS);
				std::cout << "Mwin::FL_ENTER" << std::endl;
				return 1;		
			case FL_LEAVE:
				fl_cursor(FL_CURSOR_DEFAULT);
				std::cout << "Mwin::FL_LEAVE" << std::endl;
				return 1;		

/*			case FL_MOVE:{
				return 1;
			}
*/

			default : return Fl_Overlay_Window::handle(event);
		}
	}
	void draw_overlay(){}
};


class B:public Fl_Window{
public:
	Mwin mwin;
	B():Fl_Window(300,300,"B"),mwin(0,0,200,300,"mwin"){
		resizable(&mwin);
		show();		
	}
};


int main(){
	//Mwin mwin(10,10,300,300,"mwin");	
	B b;
	return Fl::run();
}
