#include <cmath>

#include <mpp/canvas.h>
#include <mpp/draw.h>

using namespace mpp;
using namespace std;

#ifndef M_PI
	#define M_PI 3.14159265358979323846
#endif 

Scale scale(-3, 3, 0, 3);
Grid grid(-3, 0.5, 0, 0.25, scale);


class F{
public:
    F(double val=1):s(val){};
    double s;
    double operator()(double x)const{return 1/sqrt(2*M_PI*s)*exp(-x*x/(2*s));}
};

F ff;

void f(){
    while(may_i_repeat()){
        ff.s*=1+1e-2;
        ask_update();
		msleep(1e-2);
    }
}

void ud(){  
	pair<double, double> kk=auto_scale(ff(0.));   // rounded max value, step for grid
	scale.y2=kk.first;	
	grid.dy=kk.second;
	set_scale(scale);
	set_color(FL_WHITE);
	plot(ff,-3,3,100);           		
}
                    
int main(){	
	Canvas canvas;
	canvas.add_shape(new User_draw(ud));
	canvas.add_shape(grid);
	set_work(f);
	start();
	return run();
}
