#include <cmath>

#ifndef M_PI
#define M_PI		3.14159265358979323846
#endif

#include <mpp/canvas.h>
#include <mpp/draw.h>

using namespace std;
using namespace mpp;


double t=0, dt=0.02;
Scale scale(0, 10*M_PI,-2.5,+2.5);
Roll roll(FL_GREEN, scale);

void f() {
    while(may_i_repeat()) {
        t+=dt;
        //lock();
        roll.add(t, cos(t)+cos(1.2*t));
        msleep(0.01);
        //unlock();
        ask_update();
    }
}


int main() {
    Canvas canvas("Canvas example");
    canvas.add_shape(roll);
    canvas.add_shape(new Grid(0, 2*M_PI, -2.5, 0.5, scale));
    canvas.scale(scale, "time = ", "y = ");
    set_work(f);
    start();
    return run();
}
