#include <vector>
#include <list>
#include <cmath>

#include <FL/Fl_Menu_Button.H>


#include <mpp/canvas.h>
#include <mpp/draw.h>

using namespace mpp;
using namespace std;

const int sz=200;
Scale scale(-1, 1, -1, 1, KEEP_RATIO);
double          x[sz],  y[sz];
vector<double>  vx(sz), vy(sz);
list<double>    lx,     ly;

class F{
public:
    F(double val):val(val){};
    double val;
    double operator()(double)const{return val;}
};

void ud(){  
	set_scale(scale);
	point_size=0;
	set_color(FL_WHITE);
							plot(x, x+sz, y);
	set_color(FL_RED);
							plot(vx.begin(), vx.end(), vy.begin());
    set_color(FL_GREEN);
							plot(lx.begin(), lx.end(), ly.begin());
    set_color(FL_BLUE);
							plot(F(0.5), -1, 1, sz);
	point_size=1;
	set_color(FL_YELLOW);
							plot(sin, -1, 1, sz);
	point_size=2;
	for (int i=0; i<sz; i++)
		point(x[i], y[i]*0.9);
		
}

int main(){
   double xx=2./(sz-1);
   for (int i=0; i<sz; ++i) {
		vx[i]=x[i]=i*xx-1.;
		lx.push_back(x[i]);
		y[i]=x[i]*x[i]*x[i];
		vy[i]=y[i]*0.5;
		ly.push_back(y[i]*0.25);
   }
	Canvas canvas(300,300,"kk");
	canvas.add_shape(new User_draw(ud));
	canvas.add_shape(new Plot<const double*>(x, x+sz, y, FL_WHITE, scale));
	canvas.add_shape(new Grid(-1, 0.25, -1, 0.25, scale));	
	canvas.scale(scale);
      
	return run();
}
