#include <cmath>
#include <iostream>
#include <fstream>

#ifndef M_PI
	#define M_PI 3.14159265358979323846
#endif 

#include <mpp/mpp_window.h>
#include <mpp/draw.h>
#include <mpp/grabbing.h>

using namespace mpp;
using namespace std;

const int W=1000, H=1000;
double array[H][W];

Mpp_window win;	

Scale scale(-1, 1, -1, 1, KEEP_RATIO), scale2(0,W,H,0,KEEP_RATIO);


double phi=0, d_phi=5e-2, x, y;
int counter=1000;

void f(){
    while(may_i_repeat()){
        phi+=d_phi;
        x=cos(phi);
        y=sin(phi);
		// msleep(0.1);
		/*grabbing(win.canvas, "out_NONE.tif",    COMPRESSION_NONE);
		grabbing(win.canvas, "out_DEFLATE.tif", COMPRESSION_DEFLATE);		
		grabbing(win.canvas, "out_JPEG.tif",    COMPRESSION_JPEG);	*/
		
		
		//grabbing_png(win.canvas, "1.png");	
		//grabbing_eps(dynamic_cast<Fl_Window *>(&win), i2a(counter++,".eps"));
		grabbing_eps(&(win.canvas), i2a(counter,".eps"));
		grabbing_png(&(win.canvas), i2a(counter,".png"), 300);
		counter++;	
		ask_update();
    }
	
}

void ud(){
    set_scale(scale);
    set_color(FL_GREEN);
    line(0,0,x,y);
	set_color(FL_RED);
	line(0,0,-x,-y);		
}

int main(){		
	for (int i=0; i<H; i++)
	for (int j=0; j<W; j++)
		array[i][j]=(i+j)*1.0/(W+H);
	win.table.add_item("phi = ", phi);
	win.table.add_item("d_phi = ", d_phi);
	win.table.add_item("x = ", x);
	win.table.add_item("y = ", y);
	win.canvas.add_shape(new User_draw(ud));
	//win.canvas.add_shape(new Bitmap((double*)array,W,H,0.0, 1.0, scale2));
	win.canvas.scale(scale, "x = ", "y = ");
	set_work(f);
	start();
	return run();	
}

