#include <cmath>
//#include <iostream>
//#include <fstream>

//#ifndef M_PI
	//#define M_PI 3.14159265358979323846
//#endif 

#include <mpp/mpp_window.h>
#include <mpp/draw.h>
//#include <mpp/grabbing.h>

using namespace mpp;
using namespace std;

Scale scale(-1, 1, -1, 1, KEEP_RATIO);

double phi=0, d_phi=5e-6, x, y;

Mpp_window win("MPP example");

void f(){  
    while(may_i_repeat()){
        phi+=d_phi;
        x=cos(phi);
        y=sin(phi);
	ask_update();
	msleep(0.01);
    }
    win.table.tofile("table.ini");
}

void ud(){
    set_scale(scale);
    set_color(FL_WHITE);
    line(0,0,x,y);
    set_color(FL_RED);
    line(0,0,-x,-y);
}

int main(){
    win.table.add_item("phi = ", phi);
    win.table.add_item("d_phi = ", d_phi);
    win.table.add_item("x = ", x);
    win.table.add_item("y = ", y);
    win.table.fromfile("table.ini");
    //win.table.update();
    win.canvas.add_shape(new User_draw(ud));
    win.canvas.scale(scale, "x = ", "y = ");
    set_work(f);
    //start();
    return run();
}

