// Orbit test
////////////////////////////////////////////////////////////
#include <cmath>

//#include <sys/unistd.h>

#include <mpp/mpp_window.h>
#include <mpp/draw.h>

double dt=0.01;
double rtime=0;

double a1=1.0;
double a2=1.0;
double omega1=1.0;
double omega2=1.2;

using namespace mpp;

Scale s1(-1.5, 1.5, -1.5, 1.5, KEEP_RATIO);            // 
Orbit orbit(1000, 100, FL_RED, FL_WHITE, s1);        //  

void ff(){
   double x, y;
   while (may_i_repeat()){             //    
      rtime+=dt;
      x=a1*cos(omega1*rtime);
      y=a2*cos(omega2*rtime);
      orbit.add(x, y);               //    
      ask_update();           //  
      //usleep(100);
   }
};

int main(void){
	Mpp_window win;                                        //  
//   -
   win.table.add_item("dt = ", &dt);
   win.table.add_item("omega1 = ", &omega1);
   //win.table.add_item("omega2 = ", &omega2);
   //win.table.add_item("a1 = ", &a1);
   //win.table.add_item("a2 = ", &a2);

//    
   win.canvas.add_shape(&orbit);

   set_work(ff);  //    
   start();
   return run();
}
