// Roll test
#include <cmath>

#ifndef M_PI
	#define M_PI 3.14159265358979323846
#endif 

//#include <sys/unistd.h>

#include <mpp/mpp_window.h>
#include <mpp/draw.h>
    
using namespace mpp;
using namespace std;

double t=0, dt=0.025;
Scale scale(0, 10*M_PI,-2.5,+2.5);
Roll roll(FL_GREEN, scale);

void f(){ 
	while(may_i_repeat()){
		t+=dt;	
		roll.add(t, cos(t)+cos(1.2*t));			
		ask_update();
		msleep(0.001);		
	}
}


int main(){    	
	Mpp_window win;
	win.canvas.add_shape(roll);
	win.canvas.add_shape(new Grid(0, 2*M_PI, -2.5, 0.5, scale));
	win.canvas.scale(scale, "time = ", "y = ");
	win.table.add_item("Scale ", scale);
	win.table.add_item("dt ", dt);
	set_work(f);
	start();
	return run();
}
